package com.example.matule.presentation.split1.signIn

import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import cafe.adriel.voyager.core.model.ScreenModel
import cafe.adriel.voyager.core.model.screenModelScope
import com.example.matule.data.common.SupabaseClient
import com.example.matule.data.split1.AuthorizeRepository
import com.example.matule.domain.split1.request.AuthorizeRequest
import com.example.matule.domain.split1.usecase.AuthUseCase
import io.github.jan.supabase.auth.auth
import io.github.jan.supabase.auth.status.SessionStatus
import kotlinx.coroutines.flow.MutableStateFlow
import kotlinx.coroutines.flow.collect
import kotlinx.coroutines.launch

class SignInScreenModel:ScreenModel {
    val signInScreenState = MutableStateFlow(SignInState(email = "", password = ""))

    private val authorizeRepository = AuthorizeRepository()
    private val authUseCase = AuthUseCase(authorizeRepository)
    fun setEmail(email :String){
        screenModelScope.launch {
            signInScreenState.emit(signInScreenState.value.copy( email = email))
        }
    }

    fun setPassword(password :String){
        screenModelScope.launch {
            signInScreenState.emit(signInScreenState.value.copy( password = password))
        }
    }
    fun auth(){
        val authorizeRequest = AuthorizeRequest(email = signInScreenState.value.email, password = signInScreenState.value.password)
        screenModelScope.launch {
            authUseCase.authorize(authorizeRequest)
            SupabaseClient.supabase.auth.sessionStatus.collect {
               when(it){
                   is SessionStatus.Authenticated -> {
                       signInScreenState.emit(signInScreenState.value.copy(isAuthorize = true))
                   }
                   else -> {

                   }
               }
            }
        }
    }
}